local rName = GetRealmName();
local pName = UnitName("player");

function flagRSP2Options_Initialize()
	if (FlagList == nil) then
		FlagList = {};
	end
	if (FlagList[rName] == nil) then
		FlagList[rName] = {};
	end
	if (PlayerFlags == nil) then
		PlayerFlags = {};	
	end
	if (PlayerFlags[rName] == nil) then
		PlayerFlags[rName] = {};
	end
	if (PlayerFlags[rName][pName] == nil) then
		PlayerFlags[rName][pName] = {};
	end
	if (PlayerFlags[rName][pName]["CS"] == nil) then
		PlayerFlags[rName][pName]["CS"] = 2;
		flagRSP2OptionsCSSlider:SetValue(PlayerFlags[rName][pName]["CS"])
	else
		flagRSP2OptionsCSSlider:SetValue(PlayerFlags[rName][pName]["CS"])
	end
	if (PlayerFlags[rName][pName]["RP"] == nil) then
		PlayerFlags[rName][pName]["RP"] = 2;
		flagRSP2OptionsRPSlider:SetValue(PlayerFlags[rName][pName]["RP"])
	else
		flagRSP2OptionsRPSlider:SetValue(PlayerFlags[rName][pName]["RP"])
	end

	if (PlayerFlags[rName][pName]["SaveDesc"] == nil) then
		PlayerFlags[rName][pName]["SaveDesc"] = 1;
		flagRSP2OptionsSaveDescCheck:SetChecked(1);
		flagRSP2OptionsShowDescCheck:Enable();
		flagRSP2OptionsTargetDescCheck:Enable();
		flagRSP2OptionsStickyDescCheck:Enable();
		flagRSP2OptionsWordLimitCheck:Enable();
	else
		flagRSP2OptionsSaveDescCheck:SetChecked(PlayerFlags[rName][pName]["SaveDesc"]);
		if (flagRSP2OptionsSaveDescCheck:GetChecked() == 1) then
			flagRSP2OptionsShowDescCheck:Enable();
			flagRSP2OptionsTargetDescCheck:Enable();
			flagRSP2OptionsStickyDescCheck:Enable();
			flagRSP2OptionsWordLimitCheck:Enable();
		else
			flagRSP2OptionsShowDescCheck:Disable();
			flagRSP2OptionsTargetDescCheck:Disable();
			flagRSP2OptionsStickyDescCheck:Disable();
			flagRSP2OptionsWordLimitCheck:Disable();
			flagRSP2Info_Frame:Hide();
		end
	end
		if (PlayerFlags[rName][pName]["ShowDesc"] == nil) then
			PlayerFlags[rName][pName]["ShowDesc"] = 1;
			flagRSP2OptionsShowDescCheck:SetChecked(1);
		else
			flagRSP2OptionsShowDescCheck:SetChecked(PlayerFlags[rName][pName]["ShowDesc"]);
		end
		if (PlayerFlags[rName][pName]["TargetDesc"] == nil) then
			PlayerFlags[rName][pName]["TargetDesc"] = 0;
			flagRSP2OptionsTargetDescCheck:SetChecked(0);
		else
			flagRSP2OptionsTargetDescCheck:SetChecked(PlayerFlags[rName][pName]["TargetDesc"]);
		end
		if (PlayerFlags[rName][pName]["StickyDesc"] == nil) then
			PlayerFlags[rName][pName]["StickyDesc"] = 0;
			flagRSP2OptionsStickyDescCheck:SetChecked(0);
		else
			flagRSP2OptionsStickyDescCheck:SetChecked(PlayerFlags[rName][pName]["StickyDesc"]);
		end
		if (PlayerFlags[rName][pName]["HideCombat"] == nil) then
			PlayerFlags[rName][pName]["HideCombat"] = 1;
			flagRSP2OptionsHideCombatCheck:SetChecked(1);
		else
			flagRSP2OptionsHideCombatCheck:SetChecked(PlayerFlags[rName][pName]["HideCombat"]);
		end
		if (PlayerFlags[rName][pName]["WordLimit"] == nil) then
			PlayerFlags[rName][pName]["WordLimit"] = 0;
			flagRSP2OptionsWordLimitCheck:SetChecked(0);
		else
			flagRSP2OptionsWordLimitCheck:SetChecked(PlayerFlags[rName][pName]["WordLimit"]);
		end

	if (PlayerFlags[rName][pName]["FName"] == nil) then
		PlayerFlags[rName][pName]["FName"] = "";
	else
		flagRSP2PlayerFNameEdit:SetText(PlayerFlags[rName][pName]["FName"]);
	end
	if (PlayerFlags[rName][pName]["LName"] == nil) then
		PlayerFlags[rName][pName]["LName"] = "";
	else
		flagRSP2PlayerLNameEdit:SetText(PlayerFlags[rName][pName]["LName"]);
	end
	flagRSP2Player_NameDisplayText:SetText(PlayerFlags[rName][pName]["FName"] .. " " .. pName .. " " .. PlayerFlags[rName][pName]["LName"]);
	if (PlayerFlags[rName][pName]["Title"] == nil) then
		PlayerFlags[rName][pName]["Title"] = "";
	else
		flagRSP2PlayerTitleEdit:SetText(PlayerFlags[rName][pName]["Title"]);
	end
	if (PlayerFlags[rName][pName]["Desc"] == nil) then
		PlayerFlags[rName][pName]["Desc"] = {};
		PlayerFlags[rName][pName]["Desc"]["A"] = "";
	else
		flagRSP2PlayerDescEdit:SetText(PlayerFlags[rName][pName]["Desc"]["A"]);
	end

	if (PlayerFlags[rName][pName]["DV"] == nil) then
		PlayerFlags[rName][pName]["DV"] = -1;
	end

	--TOOLTIP OPTIONS-
	if (PlayerFlags[rName][pName]["TTLight"] == nil) then
		PlayerFlags[rName][pName]["TTLight"] = 0;
		flagRSP2TooltipLightModeCheck:SetChecked(0);
	else
		flagRSP2TooltipLightModeCheck:SetChecked(PlayerFlags[rName][pName]["TTLight"]);
	end
	if (PlayerFlags[rName][pName]["FRSP2TT"] == nil) then
		PlayerFlags[rName][pName]["FRSP2TT"] = 1;
		flagRSP2TooltipFRSP2TTCheck:SetChecked(1);
	else
		flagRSP2TooltipFRSP2TTCheck:SetChecked(PlayerFlags[rName][pName]["FRSP2TT"]);
	end
	if (PlayerFlags[rName][pName]["ShowAddName"] == nil) then
		PlayerFlags[rName][pName]["ShowAddName"] = 1;
		flagRSP2TooltipShowAddNameCheck:SetChecked(1);
	else
		flagRSP2TooltipShowAddNameCheck:SetChecked(PlayerFlags[rName][pName]["ShowAddName"]);
	end
	if (PlayerFlags[rName][pName]["ShowTitle"] == nil) then
		PlayerFlags[rName][pName]["ShowTitle"] = 1;
		flagRSP2TooltipShowTitleCheck:SetChecked(1);
	else
		flagRSP2TooltipShowTitleCheck:SetChecked(PlayerFlags[rName][pName]["ShowTitle"]);
	end
	if (PlayerFlags[rName][pName]["ShowGuild"] == nil) then
		PlayerFlags[rName][pName]["ShowGuild"] = 1;
		flagRSP2TooltipShowGuildCheck:SetChecked(1);
	else
		flagRSP2TooltipShowGuildCheck:SetChecked(PlayerFlags[rName][pName]["ShowGuild"]);
	end
	if (PlayerFlags[rName][pName]["ShowStatus"] == nil) then
		PlayerFlags[rName][pName]["ShowStatus"] = 1;
		flagRSP2TooltipShowStatusCheck:SetChecked(1);
	else
		flagRSP2TooltipShowStatusCheck:SetChecked(PlayerFlags[rName][pName]["ShowStatus"]);
	end
	if (PlayerFlags[rName][pName]["ShowPvP"] == nil) then
		PlayerFlags[rName][pName]["ShowPvP"] = 0;
		flagRSP2TooltipShowPvPCheck:SetChecked(0);
	else
		flagRSP2TooltipShowPvPCheck:SetChecked(PlayerFlags[rName][pName]["ShowPvP"]);
	end
	if (PlayerFlags[rName][pName]["ShowPvPTitle"] == nil) then
		PlayerFlags[rName][pName]["ShowPvPTitle"] = 0;
		flagRSP2TooltipShowPvPTitleCheck:SetChecked(0);
	else
		flagRSP2TooltipShowPvPTitleCheck:SetChecked(PlayerFlags[rName][pName]["ShowPvPTitle"]);
	end

	--Description Show Options
	if (PlayerFlags[rName][pName]["ShowDescTitle"] == nil) then
		PlayerFlags[rName][pName]["ShowDescTitle"] = 1;
		flagRSP2DescShowTitleCheck:SetChecked(1);
	else
		flagRSP2DescShowTitleCheck:SetChecked(PlayerFlags[rName][pName]["ShowDescTitle"]);
	end
	if (PlayerFlags[rName][pName]["ShowDescStatus"] == nil) then
		PlayerFlags[rName][pName]["ShowDescStatus"] = 1;
		flagRSP2DescShowStatusCheck:SetChecked(1);
	else
		flagRSP2DescShowStatusCheck:SetChecked(PlayerFlags[rName][pName]["ShowDescStatus"]);
	end
	FRSPLOADED = 1;
end

function flagRSP2Options_Update(option)
	statusupdate = 0;
	if (option == "timedupdate") then
		statusupdate = 1;
	end
	if (option == "textsendupdate" and textsendupdate == 1) then
		statusupdate = 1;
		textsendupdate = 0;
		if (descupdate == 1) then
			PlayerFlags[rName][pName]["DV"] = PlayerFlags[rName][pName]["DV"] + 1;
			descupdate = 0;
		end
	end
	if (option == flagRSP2OptionsCSSlider or flagRSP2OptionsRPSlider) then
		if (option == flagRSP2OptionsCSSlider) then
			if (PlayerFlags[rName][pName]["CS"] ~= flagRSP2OptionsCSSlider:GetValue()) then
				statusupdate = 1;
			end
			PlayerFlags[rName][pName]["CS"] = flagRSP2OptionsCSSlider:GetValue();
			if (PlayerFlags[rName][pName]["CS"] == 0) then
				getglobal(this:GetName().."Text"):SetText(FLAGRSP2_LUA_CSH);
			elseif (PlayerFlags[rName][pName]["CS"] == 1) then
				getglobal(this:GetName().."Text"):SetText(FLAGRSP2_LUA_OOC);
			elseif (PlayerFlags[rName][pName]["CS"] == 2) then
				getglobal(this:GetName().."Text"):SetText(FLAGRSP2_LUA_IC);
			elseif (PlayerFlags[rName][pName]["CS"] == 3) then
				getglobal(this:GetName().."Text"):SetText(FLAGRSP2_LUA_LFC);
			elseif (PlayerFlags[rName][pName]["CS"] == 4) then
				getglobal(this:GetName().."Text"):SetText(FLAGRSP2_LUA_ST);
			end
		end
		if (option == flagRSP2OptionsRPSlider) then
			if (PlayerFlags[rName][pName]["RP"] ~= flagRSP2OptionsRPSlider:GetValue()) then
				statusupdate = 1;
			end
			PlayerFlags[rName][pName]["RP"] = flagRSP2OptionsRPSlider:GetValue();
			if (PlayerFlags[rName][pName]["RP"] == 0) then
				getglobal(this:GetName().."Text"):SetText(FLAGRSP2_LUA_RSH);
			elseif (PlayerFlags[rName][pName]["RP"] == 1) then
				getglobal(this:GetName().."Text"):SetText(FLAGRSP2_LUA_RP);
			elseif (PlayerFlags[rName][pName]["RP"] == 2) then
				getglobal(this:GetName().."Text"):SetText(FLAGRSP2_LUA_CRP);
			elseif (PlayerFlags[rName][pName]["RP"] == 3) then
				getglobal(this:GetName().."Text"):SetText(FLAGRSP2_LUA_FRP);
			elseif (PlayerFlags[rName][pName]["RP"] == 4) then
				getglobal(this:GetName().."Text"):SetText(FLAGRSP2_LUA_BRP);
			end
		end
	end
	
	if (option == flagRSP2OptionsSaveDescCheck) then
		if (flagRSP2OptionsSaveDescCheck:GetChecked() == 1) then
			PlayerFlags[rName][pName]["SaveDesc"] = 1;
			flagRSP2OptionsShowDescCheck:Enable();
			flagRSP2OptionsTargetDescCheck:Enable();
			flagRSP2OptionsStickyDescCheck:Enable();
			flagRSP2OptionsWordLimitCheck:Enable();
		else
			PlayerFlags[rName][pName]["SaveDesc"] = 0;
			flagRSP2OptionsShowDescCheck:Disable();
			flagRSP2OptionsTargetDescCheck:Disable();
			flagRSP2OptionsStickyDescCheck:Disable();
			flagRSP2OptionsWordLimitCheck:Disable();
			flagRSP2Info_Frame:Hide();
		end
	end
		if (option == flagRSP2OptionsShowDescCheck) then
			if (flagRSP2OptionsShowDescCheck:GetChecked() == 1) then
				PlayerFlags[rName][pName]["ShowDesc"] = 1;
			else
				PlayerFlags[rName][pName]["ShowDesc"] = 0;
				flagRSP2Info_Frame:Hide();
			end
		end
		if (option == flagRSP2OptionsTargetDescCheck) then
			if (flagRSP2OptionsTargetDescCheck:GetChecked() == 1) then
				PlayerFlags[rName][pName]["TargetDesc"] = 1;
			else
				PlayerFlags[rName][pName]["TargetDesc"] = 0;
			end
		end
		if (option == flagRSP2OptionsStickyDescCheck) then
			if (flagRSP2OptionsStickyDescCheck:GetChecked() == 1) then
				PlayerFlags[rName][pName]["StickyDesc"] = 1;
			else
				PlayerFlags[rName][pName]["StickyDesc"] = 0;
			end
		end
		if (option == flagRSP2OptionsHideCombatCheck) then
			if (flagRSP2OptionsHideCombatCheck:GetChecked() == 1) then
				PlayerFlags[rName][pName]["HideCombat"] = 1;
			else
				PlayerFlags[rName][pName]["HideCombat"] = 0;
			end
		end
		if (option == flagRSP2OptionsWordLimitCheck) then
			if (flagRSP2OptionsWordLimitCheck:GetChecked() == 1) then
				PlayerFlags[rName][pName]["WordLimit"] = 1;
			else
				PlayerFlags[rName][pName]["WordLimit"] = 0;
			end
		end

	if (option == flagRSP2PlayerFNameEdit) then
			PlayerFlags[rName][pName]["FName"] = flagRSP2PlayerFNameEdit:GetText();
			flagRSP2Player_NameDisplayText:SetText(PlayerFlags[rName][pName]["FName"] .. " " .. pName .. " " .. PlayerFlags[rName][pName]["LName"]);
			textsendupdate = 1;
	end
	if (option == flagRSP2PlayerLNameEdit) then
			PlayerFlags[rName][pName]["LName"] = flagRSP2PlayerLNameEdit:GetText();
			flagRSP2Player_NameDisplayText:SetText(PlayerFlags[rName][pName]["FName"] .. " " .. pName .. " " .. PlayerFlags[rName][pName]["LName"]);
			textsendupdate = 1;
	end
	if (option == flagRSP2PlayerTitleEdit) then
			PlayerFlags[rName][pName]["Title"] = flagRSP2PlayerTitleEdit:GetText();
			textsendupdate = 1;
	end
	if (option == flagRSP2PlayerDescEdit) then
			if (PlayerFlags[rName][pName]["Desc"]["A"] ~= flagRSP2PlayerDescEdit:GetText()) then
				PlayerFlags[rName][pName]["Desc"]["A"] = flagRSP2PlayerDescEdit:GetText();
				descupdate = 1;
				textsendupdate = 1;
			end
	end

	--TOOLTIP OPTIONS UPDATE--
	if (option == flagRSP2TooltipLightModeCheck) then
		if (flagRSP2TooltipLightModeCheck:GetChecked() == 1) then
			PlayerFlags[rName][pName]["TTLight"] = 1;
		else
			PlayerFlags[rName][pName]["TTLight"] = 0;
		end
	end
	if (option == flagRSP2TooltipFRSP2TTCheck) then
		if (flagRSP2TooltipFRSP2TTCheck:GetChecked() == 1) then
			PlayerFlags[rName][pName]["FRSP2TT"] = 1;
		else
			PlayerFlags[rName][pName]["FRSP2TT"] = 0;
		end
	end
	if (option == flagRSP2TooltipShowAddNameCheck) then
		if (flagRSP2TooltipShowAddNameCheck:GetChecked() == 1) then
			PlayerFlags[rName][pName]["ShowAddName"] = 1;
		else
			PlayerFlags[rName][pName]["ShowAddName"] = 0;
		end
	end
	if (option == flagRSP2TooltipShowTitleCheck) then
		if (flagRSP2TooltipShowTitleCheck:GetChecked() == 1) then
			PlayerFlags[rName][pName]["ShowTitle"] = 1;
		else
			PlayerFlags[rName][pName]["ShowTitle"] = 0;
		end
	end
	if (option == flagRSP2TooltipShowGuildCheck) then
		if (flagRSP2TooltipShowGuildCheck:GetChecked() == 1) then
			PlayerFlags[rName][pName]["ShowGuild"] = 1;
		else
			PlayerFlags[rName][pName]["ShowGuild"] = 0;
		end
	end
	if (option == flagRSP2TooltipShowStatusCheck) then
		if (flagRSP2TooltipShowStatusCheck:GetChecked() == 1) then
			PlayerFlags[rName][pName]["ShowStatus"] = 1;
		else
			PlayerFlags[rName][pName]["ShowStatus"] = 0;
		end
	end
	if (option == flagRSP2TooltipShowPvPCheck) then
		if (flagRSP2TooltipShowPvPCheck:GetChecked() == 1) then
			PlayerFlags[rName][pName]["ShowPvP"] = 1;
		else
			PlayerFlags[rName][pName]["ShowPvP"] = 0;
		end
	end
	if (option == flagRSP2TooltipShowPvPTitleCheck) then
		if (flagRSP2TooltipShowPvPTitleCheck:GetChecked() == 1) then
			PlayerFlags[rName][pName]["ShowPvPTitle"] = 1;
		else
			PlayerFlags[rName][pName]["ShowPvPTitle"] = 0;
		end
	end
	--Description Show Options
	if (option == flagRSP2DescShowTitleCheck) then
		if (flagRSP2DescShowTitleCheck:GetChecked() == 1) then
			PlayerFlags[rName][pName]["ShowDescTitle"] = 1;
		else
			PlayerFlags[rName][pName]["ShowDescTitle"] = 0;
		end
	end
	if (option == flagRSP2DescShowStatusCheck) then
		if (flagRSP2DescShowStatusCheck:GetChecked() == 1) then
			PlayerFlags[rName][pName]["ShowDescStatus"] = 1;
		else
			PlayerFlags[rName][pName]["ShowDescStatus"] = 0;
		end
	end


	--Time to compose simple update messages.  Everything except for description will be sent in this step.  CSM stands for composed simple message.
	if (statusupdate == 1) then
		csm = "";
		csm = "<CS" .. PlayerFlags[rName][pName]["CS"] .. ">";
		csm = csm .. "<RP" .. PlayerFlags[rName][pName]["RP"] .. ">";
		csm = csm .. "<DV>" .. PlayerFlags[rName][pName]["DV"] .. "<AN1>" .. PlayerFlags[rName][pName]["FName"] .. "<AN3>" .. PlayerFlags[rName][pName]["LName"] .. "<T>" .. PlayerFlags[rName][pName]["Title"];
		--cid, cname = GetChannelName("xtensionxtooltip2");
		--SendChatMessage(csm, "CHANNEL", GetDefaultLanguage("player"), cid);
		i = getn(rspsendbuffer);
		i = i + 1
		rspsendbuffer[i] = csm;
		statusupdate = 0;
	end
end